package com.fr.plugin.lazy.sheet.fun;

import com.fanruan.api.report.view.BaseViewActor;
import com.fr.intelli.record.Focus;
import com.fr.main.TemplateWorkBook;
import com.fr.main.workbook.ResultWorkBook;
import com.fr.record.analyzer.EnableMetrics;

import java.util.Map;

/**
 * Created by richie on 15/7/17.
 */
@EnableMetrics
public class LazySheetViewActor extends BaseViewActor {

    @Override
    @Focus(id = LazyConstants.PLUGIN_ID, text = "Plugin-Lazy_Load_Sheet")
    public ResultWorkBook run(TemplateWorkBook workBook, Map parameterMap, int sheetIndex) {
        if (parameterMap.containsKey("__lazy__")) {
            return lazyExecute(workBook, parameterMap, sheetIndex);
        } else {
            return super.executeWorkBook(workBook, parameterMap, sheetIndex);
        }
    }

    private ResultWorkBook lazyExecute(TemplateWorkBook workBook, Map parameterMap, int sheetIndex) {
        return new LazySheetWorkBookViewExecutor(workBook, parameterMap, sheetIndex).execute();
    }
}