package com.fr.plugin.lazy.sheet.fun;

import com.fanruan.api.report.write.BaseWriteActor;
import com.fr.intelli.record.Focus;
import com.fr.main.TemplateWorkBook;
import com.fr.main.workbook.ResultWorkBook;
import com.fr.record.analyzer.EnableMetrics;

import java.util.Map;

/**
 * @author richie
 * @version 10.0
 * Created by richie on 2019/10/14
 */
@EnableMetrics
public class LazySheetWriteActor extends BaseWriteActor {

    @Override
    @Focus(id = LazyConstants.PLUGIN_ID, text = "Plugin-Lazy_Load_Sheet")
    public ResultWorkBook run(TemplateWorkBook workBook, Map parameterMap, int sheetIndex) {
        if (parameterMap.containsKey("__lazy__")) {
            return lazyExecute(workBook, parameterMap, sheetIndex);
        } else {
            return super.executeWorkBook(workBook, parameterMap, sheetIndex);
        }
    }

    private ResultWorkBook lazyExecute(TemplateWorkBook workBook, Map parameterMap, int sheetIndex) {
        return new LazySheetWorkBookWriteExecutor(workBook, parameterMap, sheetIndex).execute();
    }
}
